// Copyright(c) 1999 arton
// Adapters.h

#ifndef __ADAPTERS_H_
#define __ADAPTERS_H_

#include "resource.h" 

/////////////////////////////////////////////////////////////////////////////
// CAdapters
class CAdapterInfo
{
public:
	std::wstring m_sCaption;
	std::wstring m_sManufacturer;
	std::wstring m_sProductName;
	std::wstring m_sServiceName;
	std::wstring m_sDeviceName;
	std::wstring m_sDescription;
	BYTE m_bMACAddress[6];
};

typedef std::vector<CAdapterInfo> AdapterArray;
typedef std::vector<CAdapterInfo>::iterator AdapterArrayIter;

class ATL_NO_VTABLE CAdapters : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CAdapters, &CLSID_AdapterCollectionEx>,
	public ISupportErrorInfo,
	public IDispatchImpl<IAdapterCollectionEx, &IID_IAdapterCollectionEx, &LIBID_MACCAPV2Lib, MACCAPLIB_MJ>
{
public:
	CAdapters() : m_hScm(NULL), m_hSrv(NULL)
	{
		m_pUnkMarshaler = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ADAPTERS)
DECLARE_GET_CONTROLLING_UNKNOWN()
DECLARE_CLASSFACTORY_SINGLETON(CAdapters)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CAdapters)
	COM_INTERFACE_ENTRY(IAdapterCollectionEx)
	COM_INTERFACE_ENTRY(IAdapterCollection)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

	HRESULT FinalConstruct();

	void FinalRelease();

	CComPtr<IUnknown> m_pUnkMarshaler;

	inline ListVars& GetAdapters() { return m_listAdapters; }
	inline AdapterArray& GetAdapterInfo() { return m_aNIC; }

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IAdaptersCollectionEx
public:
	HRESULT STDMETHODCALLTYPE get__NewEnum( 
            /* [retval][out] */ IUnknown __RPC_FAR *__RPC_FAR *ppUnk);
        
	HRESULT STDMETHODCALLTYPE get_Length( 
            /* [retval][out] */ long __RPC_FAR *pResult);

	HRESULT STDMETHODCALLTYPE get_Item( 
            /* [in] */ long index,
            /* [retval][out] */ BSTR __RPC_FAR *pRetVal);
        
	HRESULT STDMETHODCALLTYPE get_MACAddress( 
            /* [in] */ long index,
            /* [retval][out] */ VARIANT __RPC_FAR *pRetVal);
        
	HRESULT STDMETHODCALLTYPE get_VendorName( 
            /* [in] */ long index,
            /* [retval][out] */ BSTR __RPC_FAR *pRetVal);

	HRESULT STDMETHODCALLTYPE get_ServiceName( 
            /* [in] */ long index,
            /* [retval][out] */ BSTR __RPC_FAR *pRetVal);
        
	HRESULT STDMETHODCALLTYPE get_Description( 
            /* [in] */ long index,
            /* [retval][out] */ BSTR __RPC_FAR *pRetVal);

	HRESULT STDMETHODCALLTYPE get_AdapterName( 
            /* [in] */ long index,
            /* [retval][out] */ BSTR __RPC_FAR *pRetVal);

	HRESULT STDMETHODCALLTYPE get_DeviceName( 
            /* [in] */ long index,
            /* [retval][out] */ BSTR __RPC_FAR *pRetVal);
private:
	ListVars m_listAdapters;
	AdapterArray m_aNIC;
	//
	HRESULT FillDriver();
	HRESULT CreateBindParam();
	HRESULT LoadDriver();
	void ReadMACAddress();
	void CloseService();
	//
	SC_HANDLE m_hScm, m_hSrv;
};

#endif //__ADAPTERS_H_
