//----------------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#ifndef ADDRESSETH
#define ADDRESSETH
#include <winsock2.h>
//----------------------------------------------------------------------------
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <StdCtrls.hpp>
#include <Controls.hpp>
#include <Forms.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Windows.hpp>
#include <System.hpp>
#include <Mask.hpp>
#include "IPMaskEdit.h"
#include "MACCAPV2Lib_OCX.h"
#include <OleCtrls.hpp>
#include <Grids.hpp>
#include "MACCAPV2Lib_TLB.h"
//----------------------------------------------------------------------------
class TAddressInputDlg : public TForm
{
__published:
	TButton *OKBtn;
	TButton *CancelBtn;
	TAddressMaskEdit *MaskEdit;
	TRadioGroup *RadioGroup1;

	TRadioButton *RadioBtnSrc;
	TRadioButton *RadioBtnDst;
	TRadioButton *RadioBtnBi;
    TGroupBox *RadioGroup2;
    TRadioButton *RadioMAC;
    TRadioButton *RadioIP;
    TButton *RefButton;
    TMacMonitor *MacMonitor;
    TStringGrid *Grid;
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
    void __fastcall RadioAddressClick(TObject *Sender);
    void __fastcall MacMonitorRecvData(TObject *Sender,
          IMacPacket* pData, TOLEBOOL *pStop);
    void __fastcall RefButtonClick(TObject *Sender);
    void __fastcall MacMonitorStopped(TObject *Sender, long ReasonCode);
    void __fastcall GridDblClick(TObject *Sender);
private:
    int GetHashVal(AnsiString&);
	bool IPMode;
    bool fStart;
    int iRow;
	AnsiString ResultString;
    void CheckAddress(BSTR, BSTR ip = NULL);
    TStringList* listQueue;
    int currRow;
    ULONG reqAddr;
    HANDLE hAsyncTask;
    char hostent[MAXGETHOSTSTRUCT];
public:
	enum DirectionType {
		DT_BI = 2,
		DT_DST = 1,
		DT_SRC = 0,
	};
    enum AddressType {
        AT_MAC = 0,
        AT_IP = 1,
    };
	virtual __fastcall TAddressInputDlg(TComponent* AOwner);
    __fastcall ~TAddressInputDlg();
	void InitDlg(bool IP, AnsiString& devName, AnsiString& ServiceName);
	void SetDefault(DirectionType, AnsiString& as);
	inline AnsiString& GetResult() { return ResultString; }
    inline _FilterTypeConstants GetType() const { return (RadioMAC->Checked) ? FT_MACADDRESS : FT_IPADDRESS; }
	int GetDirection();
    enum {
        WM_GOTHOSTNAME = WM_APP + 1,
    };
protected:
    void __fastcall WMGotHostName(TMessage &Message);
BEGIN_MESSAGE_MAP
  MESSAGE_HANDLER(WM_GOTHOSTNAME, TMessage, WMGotHostName)
END_MESSAGE_MAP(TControl)
};
//----------------------------------------------------------------------------
extern PACKAGE TAddressInputDlg *AddressInputDlg;
//----------------------------------------------------------------------------
#endif
