// Copyright (c) 1999 arton

#ifndef __FILTERPARAM_H_
#define __FILTERPARAM_H_

#include "resource.h" 

/////////////////////////////////////////////////////////////////////////////
interface IViewFilterSite;

// CFilterParam
class ATL_NO_VTABLE CFilterParam : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CFilterParam, &CLSID_FilterParam>,
	public IObjectSafetyImpl<CFilterParam, INTERFACESAFE_FOR_UNTRUSTED_CALLER | INTERFACESAFE_FOR_UNTRUSTED_DATA>,
	public IDispatchImpl<IFilterParam, &IID_IFilterParam, &LIBID_MACCAPV2Lib, MACCAPLIB_MJ>
{
public:
	CFilterParam() : m_ftype(FT_UNKNOWN), m_fSrc(false), m_fDst(false)
	{
		m_pUnkMarshaler = NULL;
		VariantInit(&m_vValue);
	}

DECLARE_REGISTRY_RESOURCEID(IDR_FILTERPARAM)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CFilterParam)
	COM_INTERFACE_ENTRY(IFilterParam)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IObjectSafety)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		VariantClear(&m_vValue);
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

// IFilterParam
public:
	HRESULT STDMETHODCALLTYPE put_Value( 
            /* [in] */ VARIANT NewVal);
        
	HRESULT STDMETHODCALLTYPE get_Value( 
            /* [retval][out] */ VARIANT __RPC_FAR *pResult);
        
	HRESULT STDMETHODCALLTYPE put_Source( 
            /* [in] */ VARIANT_BOOL NewVal);
        
	HRESULT STDMETHODCALLTYPE get_Source( 
            /* [retval][out] */ VARIANT_BOOL __RPC_FAR *pResult);
        
	HRESULT STDMETHODCALLTYPE put_Destination( 
            /* [in] */ VARIANT_BOOL NewVal);
        
	HRESULT STDMETHODCALLTYPE get_Destination( 
            /* [retval][out] */ VARIANT_BOOL __RPC_FAR *pResult);
        
	HRESULT STDMETHODCALLTYPE put_Type( 
            /* [in] */ FilterTypeConstants NewVal);
        
	HRESULT STDMETHODCALLTYPE get_Type( 
            /* [retval][out] */ FilterTypeConstants __RPC_FAR *pRetVal);

	HRESULT STDMETHODCALLTYPE get_Valid( 
            /* [retval][out] */ VARIANT_BOOL __RPC_FAR *pResult);
private:
	VARIANT m_vValue;
	FilterTypeConstants m_ftype;
	bool m_fSrc, m_fDst;
};

#endif //__FILTERPARAM_H_
