//---------------------------------------------------------------------------
// Copyright(c) 1999 arton
#ifndef FilterdocH
#define FilterdocH

#include "MSXML_TLB.h"
/*
 <!ELEMENT filter (address | etype | ip | value | and | or | not)*>

 <!ENTITY % direction "0|1|2">

 <!ELEMENT address (#PCDATA)>
 <!ATTLIST address
  type "0|1" #IMPLIED
  direction ENTITY #IMPLIED
  value CDATA #IMPLIED
 >

 <!ELEMENT etype (#PCDATA)>
 <!ATTLIST etype
  value CDATA #IMPLIED
 >

 <!ELEMENT ip (#PCDATA)>
 <!ATTLIST ip
  type "3|5|6" #IMPLIED
  direction ENTITY #IMPLIED
  value CDATA #IMPLIED
 >

 <!ELEMENT value (#PCDATA)>
 <!ATTLIST value
  offset CDATA #IMPLIED
  data CDATA #IMPLIED
 >

 <!ELEMENT and (address | etype | ip | value | and | or | not)*>

 <!ELEMENT or (address | etype | ip | value | and | or | not)*>

 <!ELEMENT not (address | etype | ip | value | and | or)*>

*/
class TFilterDocument
{
public:
    TFilterDocument(AnsiString& filename, TCOMIXMLDOMDocument& domDoc);
    TFilterDocument(AnsiString& filename);
    TFilterDocument(TCOMIXMLDOMDocument& domDoc);
    TFilterDocument();
    ~TFilterDocument();
    void Save(TTreeNode*);
    void Load(TTreeNodes*);
    void Load(TTreeNodes*, TTreeNode* Node);
    bool IsValid();
private:
    void SaveNode(TTreeNode*, int);
    void LoadNode(IXMLDOMNodePtr, TTreeNodes*, TTreeNode* pNode = NULL);
    int GetAttr(::IXMLDOMElement*, BSTR&);
    TCOMIXMLDOMDocument domDoc;
    TFileStream* fstr;
    bool ForClipboard;
    bool fSuccess;
    static const char* tagtype[];
    void InitBstrs();
    BSTR bstrValue;
    BSTR bstrType;
    BSTR bstrDirection;
    BSTR bstrOffset;
    BSTR bstrData;
};

#endif
