//----------------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#ifndef FreePeekMainH
#define FreePeekMainH
//----------------------------------------------------------------------------
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <StdActns.hpp>
#include <ToolWin.hpp>

#include "MACCAPV2Lib_TLB.h"
#include "MSXML_TLB.h"
#include "PERFGRAP.h"
#include <Chart.hpp>
#include <TeEngine.hpp>
#include <TeeProcs.hpp>
#include <Series.hpp>

#ifndef COUNTOF
#define COUNTOF(x) (sizeof(x)/sizeof(x[0]))
#endif

#include "activscp.h"

enum FilterButtonTag {
    FBT_ADDRESS = 17,
    FBT_ETYPE,
    FBT_IP,
    FBT_VALUE,
    FBT_AND,
    FBT_OR,
    FBT_NOT,
};

enum FileActionTag {
    FAT_NEW = 0,
    FAT_OPEN,
    FAT_SAVE,
    FAT_SAVEAS,
    FAT_SEND,
    FAT_EXIT,
};
//----------------------------------------------------------------------------
class TDescriptionForm;

class TMainForm;
	interface DMacCaptureEvent : public IDispatch
	{
	public:
		DMacCaptureEvent(TMainForm* frm) : RefCount(1), Parent(frm)
		{
		}
		HRESULT STDMETHODCALLTYPE QueryInterface(
			/* [in] */ REFIID riid,
			/* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject)
		{
			if (IsEqualIID(DIID__IMacCaptureEvents, riid)
				|| IsEqualIID(IID_IUnknown, riid) || IsEqualIID(IID_IDispatch, riid))
			{
				++RefCount;
				*ppvObject = this;
				return S_OK;
			}
			return E_NOINTERFACE;
		}

		ULONG STDMETHODCALLTYPE AddRef()
		{
			return ++RefCount;
		}
		ULONG STDMETHODCALLTYPE Release()
		{
			return --RefCount;	// not release here.
		}
		HRESULT STDMETHODCALLTYPE GetTypeInfoCount(
			/* [out] */ UINT __RPC_FAR *pctinfo)
		{
			return E_NOTIMPL;
		}
		HRESULT STDMETHODCALLTYPE GetTypeInfo(
			/* [in] */ UINT iTInfo,
			/* [in] */ LCID lcid,
			/* [out] */ ITypeInfo __RPC_FAR *__RPC_FAR *ppTInfo)
		{
			return E_NOTIMPL;
		}
		HRESULT STDMETHODCALLTYPE GetIDsOfNames(
			/* [in] */ REFIID riid,
			/* [size_is][in] */ LPOLESTR __RPC_FAR *rgszNames,
			/* [in] */ UINT cNames,
			/* [in] */ LCID lcid,
			/* [size_is][out] */ DISPID __RPC_FAR *rgDispId)
		{
			return E_NOTIMPL;
		}
		HRESULT STDMETHODCALLTYPE Invoke(
			/* [in] */ DISPID dispIdMember,
			/* [in] */ REFIID riid,
			/* [in] */ LCID lcid,
			/* [in] */ WORD wFlags,
			/* [out][in] */ DISPPARAMS __RPC_FAR *pDispParams,
			/* [out] */ VARIANT __RPC_FAR *pVarResult,
			/* [out] */ EXCEPINFO __RPC_FAR *pExcepInfo,
			/* [out] */ UINT __RPC_FAR *puArgErr);
		TMainForm* Parent;
	private:
		ULONG RefCount;
};

//----------------------------------------------------------------------------
class TMainForm : public TForm
{
    friend DMacCaptureEvent;
__published:
	TOpenDialog *OpenDialog;
	TSaveDialog *SaveDialog;
        TToolBar *ToolBar1;
    TToolButton *ToolButtonOpen;
    TToolButton *ToolButtonSave;
        TToolButton *ToolButton3;
    TToolButton *ToolButtonCut;
    TToolButton *ToolButtonCopy;
    TToolButton *ToolButtonPaste;
    TToolButton *ToolButtonMail;
        TToolButton *ToolButton8;
    TToolButton *ToolButtonNewCap;
        TActionList *ActionList1;
        TAction *FileNew1;
        TAction *FileOpen1;
        TAction *FileSave1;
        TAction *FileSaveAs1;
        TAction *FileSend1;
        TAction *FileExit1;
        TEditCut *EditCut1;
        TEditCopy *EditCopy1;
        TEditPaste *EditPaste1;
        TAction *HelpAbout1;
        TStatusBar *StatusBar;
        TImageList *ImageList1;
        TMainMenu *MainMenu1;
        TMenuItem *File1;
        TMenuItem *FileNewItem;
        TMenuItem *FileOpenItem;
        TMenuItem *FileSaveItem;
        TMenuItem *FileSaveAsItem;
        TMenuItem *N1;
        TMenuItem *FileSendItem;
        TMenuItem *FileExitItem;
        TMenuItem *Edit1;
        TMenuItem *CutItem;
        TMenuItem *CopyItem;
        TMenuItem *PasteItem;
        TMenuItem *Help1;
        TMenuItem *HelpAboutItem;
    TPageControl *PageCtrl;
    TTabSheet *TabFilter;
    TTabSheet *TabCapture;
    TTabSheet *TabSetting;
    TTabSheet *AdapterSheet;
    TListBox *ListAdapters;
    TGroupBox *GroupBox1;
    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TLabel *Label4;
    TLabel *Label5;
    TLabel *Label6;
    TLabel *AdapterInfo1;
    TLabel *AdapterInfo2;
    TLabel *AdapterInfo3;
    TLabel *AdapterInfo4;
    TLabel *AdapterInfo5;
    TLabel *AdapterInfo6;
    TButton *CapButton;
    TChart *Chart;
    TLabel *CaptStat;
    TLineSeries *Series1;
    TGroupBox *GroupBox2;
    TLabel *Label9;
    TLabel *Label10;
    TEdit *EditBuffsize;
    TEdit *EditInterval;
    TUpDown *UpDownBuffSize;
    TUpDown *UpDownInterval;
    TButton *ButtonUpdate;
    TButton *ButtonCancel;
    TTreeView *FilterTree;
    TGroupBox *GroupBox3;
    TToolBar *ToolBarFilter;
    TToolButton *tbAddress;
    TToolButton *tbEtherType;
    TToolButton *tbIP;
    TToolButton *ToolButton1;
    TToolButton *tbValue;
    TToolButton *ToolButton2;
    TToolButton *tbAnd;
    TToolButton *tbOr;
    TToolButton *tbNot;
    TPopupMenu *FilterPopup;
    TMenuItem *FilterPopupSetteing;
    TMenuItem *N3;
    TMenuItem *FilterPopupNot;
    TMenuItem *N4;
    TMenuItem *FilterPopupDel;
    TMenuItem *FilterPopupOr;
    TMenuItem *FilterPopupAnd;
    TAction *EditDelete1;
    TMenuItem *FilterPopupCopy;
    TMenuItem *FilterPopupCut;
    TMenuItem *FilterPopupPaste;
    TMenuItem *DeleteItem;
    TAction *AddAnd;
    TAction *AddOr;
    TAction *AddNot;
    TAction *EditOption;
    TToolButton *ToolButton4;
    TToolButton *ToolButtonShow;
    TAction *ShowCapture1;
    TMenuItem *N5;
    TMenuItem *Show1;
    TProgressBar *ProgressBar;
    TAction *ReparseScript;
    TMenuItem *N6;
    TMenuItem *N7;
        TGroupBox *GroupBox4;
        TLabel *Label7;
        TComboBox *ComboScrpt;
	void __fastcall FileNew1Execute(TObject *Sender);
	void __fastcall FileOpen1Execute(TObject *Sender);
	void __fastcall FileSave1Execute(TObject *Sender);
	void __fastcall FileSaveAs1Execute(TObject *Sender);
	void __fastcall FileSend1Execute(TObject *Sender);
	void __fastcall FileExit1Execute(TObject *Sender);
	void __fastcall HelpAbout1Execute(TObject *Sender);
    void __fastcall AdapterSheetShow(TObject *Sender);
    void __fastcall ListAdaptersClick(TObject *Sender);
    void __fastcall CapButtonClick(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall StatusBarResize(TObject *Sender);
    void __fastcall ButtonCancelClick(TObject *Sender);
    void __fastcall ButtonUpdateClick(TObject *Sender);
    void __fastcall FilterTreeDragOver(TObject *Sender, TObject *Source,
          int X, int Y, TDragState State, bool &Accept);
    void __fastcall PageCtrlChanging(TObject *Sender, bool &AllowChange);
    void __fastcall FilterTreeDragDrop(TObject *Sender, TObject *Source,
          int X, int Y);
    void __fastcall tbfilterDragOver(TObject *Sender, TObject *Source,
          int X, int Y, TDragState State, bool &Accept);
    void __fastcall FilterTreeMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall EditCut1Execute(TObject *Sender);
    void __fastcall EditActionUpdate(TObject *Sender);
    void __fastcall EditDelete1Execute(TObject *Sender);
    void __fastcall EditActionUpdateSelNeed(TObject *Sender);
    void __fastcall AddNotExecute(TObject *Sender);
    void __fastcall EditActionUpdateLeaf(TObject *Sender);
    void __fastcall AddAndOrExecute(TObject *Sender);
    void __fastcall EditActionUpdateAndOr(TObject *Sender);
    void __fastcall EditActionUpdateNOT(TObject *Sender);
    void __fastcall EditOptionExecute(TObject *Sender);
    void __fastcall FileActionUpdate(TObject *Sender);
    void __fastcall EditCopy1Execute(TObject *Sender);
    void __fastcall EditPaste1Execute(TObject *Sender);
    void __fastcall ShowCapture1Execute(TObject *Sender);
    void __fastcall ShowCapture1Update(TObject *Sender);
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall FormDeactivate(TObject *Sender);
    void __fastcall ReparseScriptUpdate(TObject *Sender);
    void __fastcall ReparseScriptExecute(TObject *Sender);
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
    void __fastcall FileExit1Update(TObject *Sender);
private:
	AnsiString FFileName;
	AnsiString FFilterFileName;
    AnsiString DeviceName;
    TCOMIAdapterCollectionEx adapters;
    TCOMIMacCapture capEngine;
    TCOMIXMLDOMDocument domDocument;
    AnsiString sStart, sStop;
    AnsiString sStartHelp, sStopHelp;
    bool fCapturing;
    DMacCaptureEvent* CaptureEventRecver;
    DWORD dwCookie;
    HRESULT Connect();
    int lastIndex;
    long Ticks;
    int TicksCount;
    long ATicks[20];
    int Packets;
    int Bytes;
    long ParamInterval;
    long ParamBuffSize;
    int ScriptIndex;
    TStringList* ProtoList;
    TStringList* ETypeList;
    TStringList* TCPPortList;
    TStringList* UDPPortList;
    bool bNoCapture;
    bool bFilterDirty;
    bool bCaptureDirty;
    void SaveFilter();
    void SaveCapture();
    void LoadFilter();
    Maccapv2lib_tlb::IFilterParam* ConvFilter(TTreeNode*);
    void SetDirection(Maccapv2lib_tlb::IFilterParam*, int);
    void CreateList(const GUID&, TStrings*);
    void PosForm(TForm*);
    void __fastcall ShowHint(TObject *Sender);
    void __fastcall OnIdle(TObject* Sender, bool& Done);
    void __fastcall MonitorEvent(long Tick, long Packets, long Bytes, VARIANT_BOOL* pSTop);
    void __fastcall Stop(long ReasonCode);
    void __fastcall ShowCapture(bool);
public:
	virtual __fastcall TMainForm(TComponent *Owner);
    inline long SaveCapture(BSTR bstr) { return capEngine->SaveData(bstr); }
    class SiteObj : public IActiveScriptSite, public IActiveScriptSiteWindow{
    public:
        SiteObj(TMainForm* p) : bClosed(true), pOuter(p)
        {
        }
        STDMETHOD(QueryInterface)(REFIID iid, void ** ppvObject)
        {
            if (IsEqualIID(iid, IID_IUnknown) || IsEqualIID(iid, IID_IActiveScriptSite))
            {
                *ppvObject = static_cast<IActiveScriptSite*>(this);
                return S_OK;
            }
            else if (IsEqualIID(iid, IID_IActiveScriptSiteWindow))
            {
                *ppvObject = static_cast<IActiveScriptSiteWindow*>(this);
                return S_OK;
            }
            return E_NOINTERFACE;
        }
        STDMETHOD_(ULONG,AddRef)()
        {
            return 1;
        }
        STDMETHOD_(ULONG,Release)()
        {
            return 1;
        }
    	STDMETHOD(GetLCID)(unsigned long*)
	    {
		    return E_NOTIMPL;
    	}
    	STDMETHOD(GetItemInfo)(LPCOLESTR pstrName, DWORD dwReturnMask, IUnknown** ppunkItem, ITypeInfo** ppTypeInfo)
    	{
            if ((dwReturnMask & SCRIPTINFO_IUNKNOWN) && _wcsicmp(L"document", pstrName) == 0)
	    	{
                return pOuter->GetDispatch()->QueryInterface(IID_IDispatch, (void**)ppunkItem);
		    }
	    	return TYPE_E_ELEMENTNOTFOUND;
    	}
    	STDMETHOD(GetDocVersionString)(BSTR* pbstrVersion)
	    {
    		*pbstrVersion = SysAllocString(L"1.0");
    		return S_OK;
	    }
    	STDMETHOD(OnScriptTerminate)(const VARIANT* pvarResult, const EXCEPINFO* pexcepinfo)
    	{
    		return S_OK;
    	}
    	STDMETHOD(OnStateChange)(SCRIPTSTATE ssScriptState)
    	{
    		if (ssScriptState == SCRIPTSTATE_CLOSED)
    		{
	    		bClosed = true;
    		}
    		return S_OK;
    	}
    	STDMETHOD(OnScriptError)(IActiveScriptError* pase);
    	STDMETHOD(OnEnterScript)()
    	{
    		return S_OK;
    	}
    	STDMETHOD(OnLeaveScript)()
    	{
    		return S_OK;
    	}
        // IActiveScriptSiteWindow
    	STDMETHOD(GetWindow)(HWND* phwnd)
	    {
            if (!phwnd) return E_POINTER;
    		*phwnd = pOuter->Handle;
            return S_OK;
        }
    	STDMETHOD(EnableModeless)(BOOL fEnable)
    	{
    		return S_OK;
    	}
        void ShowPacket(IMacPacket* pPacket);
    private:
        bool bClosed;
        TMainForm* pOuter;
    } SiteObject;
    IActiveScript* pJScript;
    
    class Dispatch : public IDispatch {
    public:
        Dispatch(TMainForm* p) : pOuter(p)
        {
        }
        STDMETHOD(QueryInterface)(REFIID iid, void ** ppvObject)
        {
            if (IsEqualIID(iid, IID_IUnknown) || IsEqualIID(iid, IID_IDispatch))
            {
                *ppvObject = this;
                return S_OK;
            }
            return E_NOINTERFACE;
        }
        STDMETHOD_(ULONG,AddRef)()
        {
            return 1;
        }
        STDMETHOD_(ULONG,Release)()
        {
            return 1;
        }
        STDMETHOD(GetTypeInfoCount)(unsigned int FAR *iTInfo)
	    {
		    return E_NOTIMPL;
    	}
        STDMETHOD(GetTypeInfo)(unsigned int iTInfo, LCID lcid, ITypeInfo FAR* FAR* ppTInfo)
	    {
		    return E_NOTIMPL;
    	}
        STDMETHOD(GetIDsOfNames)(
          REFIID riid,
          LPOLESTR* rgszNames,
          unsigned int cNames,
          LCID lcid,
          DISPID FAR* rgDispId);
        STDMETHOD(Invoke)(
          DISPID dispIdMember,
          REFIID riid,
          LCID lcid,
          WORD wFlags,
          DISPPARAMS FAR* pDispParams,
          VARIANT FAR* pVarResult,
          EXCEPINFO FAR* pExcepInfo,
          unsigned int FAR* puArgErr);
          inline void SetDescForm(TDescriptionForm* p) { pDescForm = p; }
    private:
        void Write(AnsiString s);
        void WriteLine(AnsiString s);
        void Alert(AnsiString s);
        HRESULT Dump(DISPPARAMS FAR* pDispParams);
        void Color(long);
        void Size(long);
        void Bold(bool);
        void Italic(bool);
        AnsiString TcpPort(long);
        AnsiString UdpPort(long);
        AnsiString ICMPType(long);
        enum {
            DID_WRITE = 1,
            DID_WRITELINE,
            DID_ALERT,
            DID_DUMP,
            DID_COLOR,
            DID_SIZE,
            DID_BOLD,
            DID_ITALIC,
            DID_TCPPORT,
            DID_UDPPORT,
            DID_ICMPTYPE,
        };
        TMainForm* pOuter;
        TDescriptionForm* pDescForm;
    } DispObj;
    inline IDispatch* GetDispatch() { return &DispObj; }
    inline void SetDescForm(TDescriptionForm* p) { DispObj.SetDescForm(p); }
    inline bool ScriptAvail() const { return !(pJScript == NULL); }
    void ParseRootScript();
};
//----------------------------------------------------------------------------
extern TMainForm *MainForm;
//----------------------------------------------------------------------------
#endif
